#ifndef __LIBMONETRA_DEFINES_H__
#define __LIBMONETRA_DEFINES_H__

/* Key definitions for Transaction Parameters */
#define MC_TRANTYPE		1
#define MC_USERNAME		2
#define MC_PASSWORD		3
#define MC_ACCOUNT		4
#define MC_TRACKDATA		5
#define MC_EXPDATE		6
#define MC_STREET		7
#define MC_ZIP			8
#define MC_CV			9
#define MC_COMMENTS		10
#define MC_CLERKID		11
#define MC_STATIONID		12
#define MC_APPRCODE		13
#define MC_AMOUNT		14
#define MC_PTRANNUM		15
#define MC_TTID			16
#define MC_USER			17
#define MC_PWD			18
#define MC_ACCT			19
#define MC_BDATE		20
#define MC_EDATE		21
#define MC_BATCH		22
#define MC_FILE			23
#define MC_ADMIN		24
#define MC_AUDITTYPE		25
#define MC_CUSTOM		26
/* restaurant, lodging, auto-rental */
#define MC_EXAMOUNT     	27
#define MC_EXCHARGES    	28
#define MC_RATE         	29
#define MC_RENTERNAME   	30
#define MC_RETURNCITY   	31
#define MC_RETURNSTATE  	32
#define MC_RETURNLOCATION       33
#define MC_PRIORITY		34
#define MC_INQUIRY		35

#define MC_CARDTYPES		36
#define MC_SUB			37
#define MC_MARKER		38
#define MC_DEVICETYPE		39
#define MC_ERRORCODE		40
#define MC_NEWBATCH		41
#define MC_CURR			42
#define MC_DESCMERCH		43
#define MC_DESCLOC		44
#define MC_ORIGTYPE		45
#define MC_PIN			46
#define MC_VOIDORIGTYPE		47
#define MC_TIMESTAMP            48



/* Priorities */
#define MC_PRIO_HIGH	1
#define MC_PRIO_NORMAL	2
#define MC_PRIO_LOW	3


/* Excharges for lodging and auto-rental*/
#define MC_EXCHARGES_REST         1
#define MC_EXCHARGES_GIFT         2
#define MC_EXCHARGES_MINI         3
#define MC_EXCHARGES_TELE         4
#define MC_EXCHARGES_OTHER        5
#define MC_EXCHARGES_LAUND        6
#define MC_EXCHARGES_NONE         7

#define MC_EXCHARGES_GAS          8
#define MC_EXCHARGES_MILE         9
#define MC_EXCHARGES_LATE         10
#define MC_EXCHARGES_1WAY         11
#define MC_EXCHARGES_VIOL         12


/* Args for adding a user */
#define MC_USER_PROC		2000
#define MC_USER_USER		2001
#define MC_USER_PWD		2002
#define MC_USER_INDCODE		2003
#define MC_USER_MERCHID		2004
#define MC_USER_BANKID		2005
#define MC_USER_TERMID		2006
#define MC_USER_CLIENTNUM	2007
#define MC_USER_STOREID		2008
#define MC_USER_AGENTID		2009
#define MC_USER_CHAINID		2010
#define MC_USER_ZIPCODE		2011
#define MC_USER_TIMEZONE	2012
#define MC_USER_MERCHCAT	2013
#define MC_USER_MERNAME		2014
#define MC_USER_MERCHLOC	2015
#define MC_USER_STATECODE	2016
#define MC_USER_PHONE		2017
#define MC_USER_SUB		2018
#define MC_USER_CARDTYPES	2019
#define MC_USER_MODE		2020
#define MC_USER_VNUMBER		2021
#define MC_USER_ROUTINGID	2022
#define MC_USER_PPROPERTY	2023
#define MC_USER_PID		2024
#define MC_USER_PIDPWD		2025
#define MC_USER_SMID		2026
#define MC_USER_SMIDPWD		2027
#define MC_USER_USDDIV		2028
#define MC_USER_AUDDIV		2029
#define MC_USER_DKKDIV		2030
#define MC_USER_GBPDIV		2031
#define MC_USER_HKDDIV		2032
#define MC_USER_JPYDIV		2033
#define MC_USER_NZDDIV		2034
#define MC_USER_NOKDIV		2035
#define MC_USER_SGDDIV		2036
#define MC_USER_ZARDIV		2037
#define MC_USER_SEKDIV		2038
#define MC_USER_CHFDIV		2039
#define MC_USER_CADDIV		2040
#define MC_USER_DIVNUM          2041


/* Card Types */
#define MC_CARD_VISA	2
#define MC_CARD_MC	4
#define MC_CARD_AMEX	8
#define MC_CARD_DISC	16
#define MC_CARD_JCB	32
#define MC_CARD_CB	64
#define MC_CARD_DC	128
#define MC_CARD_GIFT	256
#define MC_CARD_OTHER	512
#define MC_CARD_ALL 	(MC_CARD_VISA|MC_CARD_MC|MC_CARD_AMEX|MC_CARD_DISC|MC_CARD_JCB|MC_CARD_CB|MC_CARD_DC|MC_CARD_GIFT|MC_CARD_OTHER)

/* Modes */
#define MC_MODE_AUTH	2
#define MC_MODE_SETTLE	4
#define MC_MODE_BOTH	(MC_MODE_AUTH|MC_MODE_SETTLE)
#define MC_MODE_ALL	MC_MODE_BOTH

/* Value definitions for Transaction Types */
#define MC_TRAN_SALE		1
#define MC_TRAN_REDEMPTION	MC_TRAN_SALE
#define MC_TRAN_PREAUTH		2
#define MC_TRAN_VOID		3
#define MC_TRAN_PREAUTHCOMPLETE	4
#define MC_TRAN_FORCE		5
#define MC_TRAN_OVERRIDE	6
#define MC_TRAN_RETURN		7
#define MC_TRAN_RELOAD		MC_TRAN_RETURN
#define MC_TRAN_CREDIT		MC_TRAN_RETURN
#define MC_TRAN_SETTLE		8
#define MC_TRAN_INCREMENTAL    	9
#define MC_TRAN_REVERSAL        10
#define MC_TRAN_ACTIVATE	11
#define MC_TRAN_BALANCEINQ	12
#define MC_TRAN_CASHOUT		13
#define MC_TRAN_TOREVERSAL	14
#define MC_TRAN_SETTLERFR	15
#define MC_TRAN_ISSUE		16
#define MC_TRAN_TIP		17
#define MC_TRAN_MERCHRETURN	18
#define MC_TRAN_IVRREQ		19
#define MC_TRAN_IVRRESP	 	20
#define MC_TRAN_ADMIN		50
#define MC_TRAN_PING		100
#define MC_TRAN_CHKPWD		200


/* Engine Admin Transaction Types */
#define MC_TRAN_CHNGPWD		1001
#define MC_TRAN_LISTSTATS	1002
#define MC_TRAN_LISTUSERS	1003
#define MC_TRAN_GETUSERINFO	1004
#define MC_TRAN_ADDUSER		1005
#define MC_TRAN_EDITUSER	1006
#define MC_TRAN_DELUSER		1007
#define MC_TRAN_ENABLEUSER	1008
#define MC_TRAN_DISABLEUSER	1009
#define MC_TRAN_IMPORT		1010
#define MC_TRAN_EXPORT		1011
#define MC_TRAN_ERRORLOG	1012
#define MC_TRAN_CLEARERRORLOG	1013
#define MC_TRAN_GETSUBACCTS	1014


/* Value definitions for Admin Types */
#define MC_ADMIN_GUT		1
#define MC_ADMIN_GL		2
#define MC_ADMIN_GFT		3
#define MC_ADMIN_BT		4
#define MC_ADMIN_UB		MC_ADMIN_BT
#define MC_ADMIN_QC		5
#define MC_ADMIN_RS		6
#define MC_ADMIN_CTH		7
#define MC_ADMIN_CFH		8
#define MC_ADMIN_FORCESETTLE	9
#define MC_ADMIN_SETBATCHNUM	10
#define MC_ADMIN_RENUMBERBATCH	11
#define MC_ADMIN_FIELDEDIT	12
#define MC_ADMIN_CLOSEBATCH	13

#define M_SALE MC_TRAN_SALE
#define M_PREAUTH MC_TRAN_PREAUTH
#define M_FORCE MC_TRAN_FORCE
#define M_OVERRIDE MC_TRAN_OVERRIDE
#define M_RETURN MC_TRAN_RETURN
#define M_VOID MC_TRAN_VOID
#define M_SETTLE MC_TRAN_SETTLE


// USER SETUP INFORMATION
#define M_PROC MC_USER_PROC
#define M_USER MC_USER_USER
#define M_PWD MC_USER_PWD
#define M_INDCODE MC_USER_INDCODE
#define M_MERCHID MC_USER_MERCHID
#define M_BANKID MC_USER_BANKID
#define M_TERMID MC_USER_TERMID
#define M_CLIENTNUM MC_USER_CLIENTNUM
#define M_STOREID MC_USER_STOREID
#define M_AGENTID MC_USER_AGENTID
#define M_CHAINID MC_USER_CHAINID
#define M_ZIPCODE MC_USER_ZIPCODE
#define M_TIMEZONE MC_USER_TIMEZONE
#define M_MERCHCAT MC_USER_MERCHCAT
#define M_MERNAME MC_USER_MERNAME
#define M_MERCHLOC MC_USER_MERCHLOC
#define M_STATECODE MC_USER_STATECODE
#define M_SERVICEPHONE MC_USER_PHONE


#endif
